Subject: bug#50679: 28.0.50; outline-minor-mode-cycle should be able to only cycle at the begining of a line

From: Augusto Stoffel <[email-masked]>
Date: Mon, 20 Sep 2021 20:36:54 +0200

On Mon, 20 Sep 2021 at 15:35, Philip Kaludercic <[email-masked]> wrote:

> Juri Linkov <[email-masked]> writes:
>
>>>> I didn't necessarily propose anything, it might only be able to solve
>>>> this using a option like
>>>>
>>>>      (defcustom outline-minor-mode-cycle-predicate ...)
>>>>
>>>> as to allow for users to configure cycling as they see fit. Of course if
>>>> some consistent behaviour could be found that respects other options and
>>>> modes, then something automatic could also be used.
>>>
>>> Probably offloading the decision to the users with a customizable option
>>> is all what we can do here, indeed.
>>
>> Maybe something like:
>>
>>  (defvar outline-mode-cycle-map
>>    (let ((map (make-sparse-keymap)))
>>      (let ((tab-binding `(menu-item
>>                           "" outline-cycle
>>                           ;; Only takes effect if point is on a heading.
>>                           :filter ,(lambda (cmd)
>> -                                    (when (outline-on-heading-p) cmd)))))
>> +                                    (when (and (outline-on-heading-p)
>> +                                               (or (not (functionp outline-mode-cycle-filter))
>> +                                                   (funcall outline-mode-cycle-filter)))
>> +                                      cmd)))))
>>        (define-key map (kbd "TAB") tab-binding)
>>        (define-key map (kbd "<backtab>") #'outline-cycle-buffer))
>>      map)
>>
>> Then you can customize it to 'bolp'.
>
> I just tried it out, and it looks good. The only thing I wonder is if
> this should apply to both outline-minor-mode and outline-mode?

FWIW, I think it would be nice to provide a simple way to define other
“speed keys” in `outline-minor-mode [1], or even provide some
pre-configured ones [2].

Looking at the code, it seems that adding bindings to
`outline-mode-cycle-map` would achieve precisely that, but the name
of the keymap doesn't reflect that.

[1]: Cf. https://orgmode.org/manual/Speed-Keys.html

[2]: I personally use these speed keys in outline-minor-mode, which are
probably very similar to those from Org mode:

        "<tab>" 'outline-cycle
        "<backtab>" 'outline-cycle-buffer
        "f" 'outline-forward-same-level
        "b" 'outline-backward-same-level
        "n" 'outline-next-visible-heading
        "p" 'outline-previous-visible-heading
        "u" 'outline-up-heading
        "F" 'outline-move-subtree-down
        "B" 'outline-move-subtree-up
        "@" 'outline-mark-subtree